<html devsite><head>
    <title>错误和信息流处理</title>
    <meta name="project_path" value="/_project.yaml"/>
    <meta name="book_path" value="/_book.yaml"/>
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->

<h2 id="error-mgmt">错误管理</h2>
<p>与相机交互的 HIDL 接口方法必须生成相应的相机特定<a href="https://source.android.com/reference/hidl/android/hardware/camera/common/1.0/types">状态</a>。</p>
<p>如果调用了 <a href="/reference/hidl/android/hardware/camera/device/3.2/ICameraDeviceCallback#notify">ICameraDeviceCallbacks::notify()</a> 且返回 <a href="https://source.android.com/reference/hidl/android/hardware/camera/device/3.2/types#errorcode">ERROR_DEVICE</a>，则只能成功调用 <a href="/reference/hidl/android/hardware/camera/device/3.2/ICameraDeviceSession#close">ICameraDeviceSession::close()</a> 方法。其他所有方法都将返回 <a href="/reference/hidl/android/hardware/camera/common/1.0/types#status">INTERNAL_ERROR</a>。</p>

<p>图像拍摄过程中的瞬时错误必须通过 <a href="https://source.android.com/reference/hidl/android/hardware/camera/device/3.2/ICameraDeviceCallback#notify">ICameraDeviceCallbacks::notify()</a> 进行报告且返回相应的<a href="/reference/hidl/android/hardware/camera/device/3.2/types#errorcode">错误代码</a>。在发生各种瞬时失败的情况下，HAL 必须仍然调用 <a href="/reference/hidl/android/hardware/camera/device/3.2/ICameraDeviceCallback#processcaptureresult">ICameraDeviceCallbacks::processCaptureResult()</a> 且返回相应的<a href="/reference/hidl/android/hardware/camera/device/3.2/types#captureresult">捕获结果</a>。</p>

<h2 id="stream-mgmt">信息流管理</h2>
<h3 id="configure_streams">configure_streams</h3>
<p>HAL 客户端必须通过调用 <a href="/reference/hidl/android/hardware/camera/device/3.2/ICameraDeviceSession#configurestreams">ICameraDeviceSession::configurestreams()</a> 来配置相机信息流。</p>

</body></html>